/*
 * NewsBlob - Live RSS news reader.
 * Copyright 2009 Lars Torger Høye.
 *
 * This file is part of NewsBlob.
 *
 * NewsBlob is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * NewsBlob is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with NewsBlob.  If not, see <http://www.gnu.org/licenses/>.
 */

package newsblob.feed.article;

import java.security.NoSuchAlgorithmException;
import java.util.Iterator;
import java.util.LinkedList;

/**
 *
 * @author Lars Torger Høye
 */
public class ArticleBuffer extends LinkedList<Article> {

    private final int BUFFER_SIZE = 1000;

    public void addArticle(String title, String description, String link) throws NoSuchAlgorithmException {
        addArticle(new Article(title, description, link));
    }

    public synchronized void addArticle(Article article) throws NoSuchAlgorithmException {
        super.addFirst(article);
        if(size() > BUFFER_SIZE)
            super.removeLast();
    }
/*
    public Article[] getFirstArticles(int end) {
        return getArticles(0, end);
    }

    public synchronized Article[] getArticles(int start, int end) {
        List<Article> list = super.subList(start, end);
        Article[] retArray = new Article[list.size()];
        for (int i = 0; i < retArray.length; i++) {
            retArray[i] = list.get(i);
        }
        return retArray;
    }
*/
    public boolean contains(Article article) {
        Iterator<Article> articles = iterator();
        while(articles.hasNext()) {
            if(articles.next().equals(article))
                return true;
        }
        return false;
    }


}
